/*******************************************************************************
* File Name: ADCGND.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_ADCGND_H) /* Pins ADCGND_H */
#define CY_PINS_ADCGND_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "ADCGND_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 ADCGND__PORT == 15 && ((ADCGND__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    ADCGND_Write(uint8 value);
void    ADCGND_SetDriveMode(uint8 mode);
uint8   ADCGND_ReadDataReg(void);
uint8   ADCGND_Read(void);
void    ADCGND_SetInterruptMode(uint16 position, uint16 mode);
uint8   ADCGND_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the ADCGND_SetDriveMode() function.
     *  @{
     */
        #define ADCGND_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define ADCGND_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define ADCGND_DM_RES_UP          PIN_DM_RES_UP
        #define ADCGND_DM_RES_DWN         PIN_DM_RES_DWN
        #define ADCGND_DM_OD_LO           PIN_DM_OD_LO
        #define ADCGND_DM_OD_HI           PIN_DM_OD_HI
        #define ADCGND_DM_STRONG          PIN_DM_STRONG
        #define ADCGND_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define ADCGND_MASK               ADCGND__MASK
#define ADCGND_SHIFT              ADCGND__SHIFT
#define ADCGND_WIDTH              1u

/* Interrupt constants */
#if defined(ADCGND__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in ADCGND_SetInterruptMode() function.
     *  @{
     */
        #define ADCGND_INTR_NONE      (uint16)(0x0000u)
        #define ADCGND_INTR_RISING    (uint16)(0x0001u)
        #define ADCGND_INTR_FALLING   (uint16)(0x0002u)
        #define ADCGND_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define ADCGND_INTR_MASK      (0x01u) 
#endif /* (ADCGND__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ADCGND_PS                     (* (reg8 *) ADCGND__PS)
/* Data Register */
#define ADCGND_DR                     (* (reg8 *) ADCGND__DR)
/* Port Number */
#define ADCGND_PRT_NUM                (* (reg8 *) ADCGND__PRT) 
/* Connect to Analog Globals */                                                  
#define ADCGND_AG                     (* (reg8 *) ADCGND__AG)                       
/* Analog MUX bux enable */
#define ADCGND_AMUX                   (* (reg8 *) ADCGND__AMUX) 
/* Bidirectional Enable */                                                        
#define ADCGND_BIE                    (* (reg8 *) ADCGND__BIE)
/* Bit-mask for Aliased Register Access */
#define ADCGND_BIT_MASK               (* (reg8 *) ADCGND__BIT_MASK)
/* Bypass Enable */
#define ADCGND_BYP                    (* (reg8 *) ADCGND__BYP)
/* Port wide control signals */                                                   
#define ADCGND_CTL                    (* (reg8 *) ADCGND__CTL)
/* Drive Modes */
#define ADCGND_DM0                    (* (reg8 *) ADCGND__DM0) 
#define ADCGND_DM1                    (* (reg8 *) ADCGND__DM1)
#define ADCGND_DM2                    (* (reg8 *) ADCGND__DM2) 
/* Input Buffer Disable Override */
#define ADCGND_INP_DIS                (* (reg8 *) ADCGND__INP_DIS)
/* LCD Common or Segment Drive */
#define ADCGND_LCD_COM_SEG            (* (reg8 *) ADCGND__LCD_COM_SEG)
/* Enable Segment LCD */
#define ADCGND_LCD_EN                 (* (reg8 *) ADCGND__LCD_EN)
/* Slew Rate Control */
#define ADCGND_SLW                    (* (reg8 *) ADCGND__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define ADCGND_PRTDSI__CAPS_SEL       (* (reg8 *) ADCGND__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define ADCGND_PRTDSI__DBL_SYNC_IN    (* (reg8 *) ADCGND__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define ADCGND_PRTDSI__OE_SEL0        (* (reg8 *) ADCGND__PRTDSI__OE_SEL0) 
#define ADCGND_PRTDSI__OE_SEL1        (* (reg8 *) ADCGND__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define ADCGND_PRTDSI__OUT_SEL0       (* (reg8 *) ADCGND__PRTDSI__OUT_SEL0) 
#define ADCGND_PRTDSI__OUT_SEL1       (* (reg8 *) ADCGND__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define ADCGND_PRTDSI__SYNC_OUT       (* (reg8 *) ADCGND__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(ADCGND__SIO_CFG)
    #define ADCGND_SIO_HYST_EN        (* (reg8 *) ADCGND__SIO_HYST_EN)
    #define ADCGND_SIO_REG_HIFREQ     (* (reg8 *) ADCGND__SIO_REG_HIFREQ)
    #define ADCGND_SIO_CFG            (* (reg8 *) ADCGND__SIO_CFG)
    #define ADCGND_SIO_DIFF           (* (reg8 *) ADCGND__SIO_DIFF)
#endif /* (ADCGND__SIO_CFG) */

/* Interrupt Registers */
#if defined(ADCGND__INTSTAT)
    #define ADCGND_INTSTAT            (* (reg8 *) ADCGND__INTSTAT)
    #define ADCGND_SNAP               (* (reg8 *) ADCGND__SNAP)
    
	#define ADCGND_0_INTTYPE_REG 		(* (reg8 *) ADCGND__0__INTTYPE)
#endif /* (ADCGND__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_ADCGND_H */


/* [] END OF FILE */
