/*******************************************************************************
* File Name: Button1.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_Button1_H)
#define CY_ISR_Button1_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void Button1_Start(void);
void Button1_StartEx(cyisraddress address);
void Button1_Stop(void);

CY_ISR_PROTO(Button1_Interrupt);

void Button1_SetVector(cyisraddress address);
cyisraddress Button1_GetVector(void);

void Button1_SetPriority(uint8 priority);
uint8 Button1_GetPriority(void);

void Button1_Enable(void);
uint8 Button1_GetState(void);
void Button1_Disable(void);

void Button1_SetPending(void);
void Button1_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Button1 ISR. */
#define Button1_INTC_VECTOR            ((reg32 *) Button1__INTC_VECT)

/* Address of the Button1 ISR priority. */
#define Button1_INTC_PRIOR             ((reg8 *) Button1__INTC_PRIOR_REG)

/* Priority of the Button1 interrupt. */
#define Button1_INTC_PRIOR_NUMBER      Button1__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Button1 interrupt. */
#define Button1_INTC_SET_EN            ((reg32 *) Button1__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Button1 interrupt. */
#define Button1_INTC_CLR_EN            ((reg32 *) Button1__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Button1 interrupt state to pending. */
#define Button1_INTC_SET_PD            ((reg32 *) Button1__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Button1 interrupt. */
#define Button1_INTC_CLR_PD            ((reg32 *) Button1__INTC_CLR_PD_REG)


#endif /* CY_ISR_Button1_H */


/* [] END OF FILE */
