/*******************************************************************************
* File Name: Button2.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_Button2_H)
#define CY_ISR_Button2_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void Button2_Start(void);
void Button2_StartEx(cyisraddress address);
void Button2_Stop(void);

CY_ISR_PROTO(Button2_Interrupt);

void Button2_SetVector(cyisraddress address);
cyisraddress Button2_GetVector(void);

void Button2_SetPriority(uint8 priority);
uint8 Button2_GetPriority(void);

void Button2_Enable(void);
uint8 Button2_GetState(void);
void Button2_Disable(void);

void Button2_SetPending(void);
void Button2_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Button2 ISR. */
#define Button2_INTC_VECTOR            ((reg32 *) Button2__INTC_VECT)

/* Address of the Button2 ISR priority. */
#define Button2_INTC_PRIOR             ((reg8 *) Button2__INTC_PRIOR_REG)

/* Priority of the Button2 interrupt. */
#define Button2_INTC_PRIOR_NUMBER      Button2__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Button2 interrupt. */
#define Button2_INTC_SET_EN            ((reg32 *) Button2__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Button2 interrupt. */
#define Button2_INTC_CLR_EN            ((reg32 *) Button2__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Button2 interrupt state to pending. */
#define Button2_INTC_SET_PD            ((reg32 *) Button2__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Button2 interrupt. */
#define Button2_INTC_CLR_PD            ((reg32 *) Button2__INTC_CLR_PD_REG)


#endif /* CY_ISR_Button2_H */


/* [] END OF FILE */
