/*******************************************************************************
* File Name: Button3.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_Button3_H)
#define CY_ISR_Button3_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void Button3_Start(void);
void Button3_StartEx(cyisraddress address);
void Button3_Stop(void);

CY_ISR_PROTO(Button3_Interrupt);

void Button3_SetVector(cyisraddress address);
cyisraddress Button3_GetVector(void);

void Button3_SetPriority(uint8 priority);
uint8 Button3_GetPriority(void);

void Button3_Enable(void);
uint8 Button3_GetState(void);
void Button3_Disable(void);

void Button3_SetPending(void);
void Button3_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Button3 ISR. */
#define Button3_INTC_VECTOR            ((reg32 *) Button3__INTC_VECT)

/* Address of the Button3 ISR priority. */
#define Button3_INTC_PRIOR             ((reg8 *) Button3__INTC_PRIOR_REG)

/* Priority of the Button3 interrupt. */
#define Button3_INTC_PRIOR_NUMBER      Button3__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Button3 interrupt. */
#define Button3_INTC_SET_EN            ((reg32 *) Button3__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Button3 interrupt. */
#define Button3_INTC_CLR_EN            ((reg32 *) Button3__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Button3 interrupt state to pending. */
#define Button3_INTC_SET_PD            ((reg32 *) Button3__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Button3 interrupt. */
#define Button3_INTC_CLR_PD            ((reg32 *) Button3__INTC_CLR_PD_REG)


#endif /* CY_ISR_Button3_H */


/* [] END OF FILE */
