/*******************************************************************************
* File Name: Freq_erreicht.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_Freq_erreicht_H)
#define CY_ISR_Freq_erreicht_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void Freq_erreicht_Start(void);
void Freq_erreicht_StartEx(cyisraddress address);
void Freq_erreicht_Stop(void);

CY_ISR_PROTO(Freq_erreicht_Interrupt);

void Freq_erreicht_SetVector(cyisraddress address);
cyisraddress Freq_erreicht_GetVector(void);

void Freq_erreicht_SetPriority(uint8 priority);
uint8 Freq_erreicht_GetPriority(void);

void Freq_erreicht_Enable(void);
uint8 Freq_erreicht_GetState(void);
void Freq_erreicht_Disable(void);

void Freq_erreicht_SetPending(void);
void Freq_erreicht_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Freq_erreicht ISR. */
#define Freq_erreicht_INTC_VECTOR            ((reg32 *) Freq_erreicht__INTC_VECT)

/* Address of the Freq_erreicht ISR priority. */
#define Freq_erreicht_INTC_PRIOR             ((reg8 *) Freq_erreicht__INTC_PRIOR_REG)

/* Priority of the Freq_erreicht interrupt. */
#define Freq_erreicht_INTC_PRIOR_NUMBER      Freq_erreicht__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Freq_erreicht interrupt. */
#define Freq_erreicht_INTC_SET_EN            ((reg32 *) Freq_erreicht__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Freq_erreicht interrupt. */
#define Freq_erreicht_INTC_CLR_EN            ((reg32 *) Freq_erreicht__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Freq_erreicht interrupt state to pending. */
#define Freq_erreicht_INTC_SET_PD            ((reg32 *) Freq_erreicht__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Freq_erreicht interrupt. */
#define Freq_erreicht_INTC_CLR_PD            ((reg32 *) Freq_erreicht__INTC_CLR_PD_REG)


#endif /* CY_ISR_Freq_erreicht_H */


/* [] END OF FILE */
