/*******************************************************************************
* File Name: Iout.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Iout_H) /* Pins Iout_H */
#define CY_PINS_Iout_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Iout_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Iout__PORT == 15 && ((Iout__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Iout_Write(uint8 value);
void    Iout_SetDriveMode(uint8 mode);
uint8   Iout_ReadDataReg(void);
uint8   Iout_Read(void);
void    Iout_SetInterruptMode(uint16 position, uint16 mode);
uint8   Iout_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Iout_SetDriveMode() function.
     *  @{
     */
        #define Iout_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Iout_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Iout_DM_RES_UP          PIN_DM_RES_UP
        #define Iout_DM_RES_DWN         PIN_DM_RES_DWN
        #define Iout_DM_OD_LO           PIN_DM_OD_LO
        #define Iout_DM_OD_HI           PIN_DM_OD_HI
        #define Iout_DM_STRONG          PIN_DM_STRONG
        #define Iout_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Iout_MASK               Iout__MASK
#define Iout_SHIFT              Iout__SHIFT
#define Iout_WIDTH              1u

/* Interrupt constants */
#if defined(Iout__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Iout_SetInterruptMode() function.
     *  @{
     */
        #define Iout_INTR_NONE      (uint16)(0x0000u)
        #define Iout_INTR_RISING    (uint16)(0x0001u)
        #define Iout_INTR_FALLING   (uint16)(0x0002u)
        #define Iout_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Iout_INTR_MASK      (0x01u) 
#endif /* (Iout__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Iout_PS                     (* (reg8 *) Iout__PS)
/* Data Register */
#define Iout_DR                     (* (reg8 *) Iout__DR)
/* Port Number */
#define Iout_PRT_NUM                (* (reg8 *) Iout__PRT) 
/* Connect to Analog Globals */                                                  
#define Iout_AG                     (* (reg8 *) Iout__AG)                       
/* Analog MUX bux enable */
#define Iout_AMUX                   (* (reg8 *) Iout__AMUX) 
/* Bidirectional Enable */                                                        
#define Iout_BIE                    (* (reg8 *) Iout__BIE)
/* Bit-mask for Aliased Register Access */
#define Iout_BIT_MASK               (* (reg8 *) Iout__BIT_MASK)
/* Bypass Enable */
#define Iout_BYP                    (* (reg8 *) Iout__BYP)
/* Port wide control signals */                                                   
#define Iout_CTL                    (* (reg8 *) Iout__CTL)
/* Drive Modes */
#define Iout_DM0                    (* (reg8 *) Iout__DM0) 
#define Iout_DM1                    (* (reg8 *) Iout__DM1)
#define Iout_DM2                    (* (reg8 *) Iout__DM2) 
/* Input Buffer Disable Override */
#define Iout_INP_DIS                (* (reg8 *) Iout__INP_DIS)
/* LCD Common or Segment Drive */
#define Iout_LCD_COM_SEG            (* (reg8 *) Iout__LCD_COM_SEG)
/* Enable Segment LCD */
#define Iout_LCD_EN                 (* (reg8 *) Iout__LCD_EN)
/* Slew Rate Control */
#define Iout_SLW                    (* (reg8 *) Iout__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Iout_PRTDSI__CAPS_SEL       (* (reg8 *) Iout__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Iout_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Iout__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Iout_PRTDSI__OE_SEL0        (* (reg8 *) Iout__PRTDSI__OE_SEL0) 
#define Iout_PRTDSI__OE_SEL1        (* (reg8 *) Iout__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Iout_PRTDSI__OUT_SEL0       (* (reg8 *) Iout__PRTDSI__OUT_SEL0) 
#define Iout_PRTDSI__OUT_SEL1       (* (reg8 *) Iout__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Iout_PRTDSI__SYNC_OUT       (* (reg8 *) Iout__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Iout__SIO_CFG)
    #define Iout_SIO_HYST_EN        (* (reg8 *) Iout__SIO_HYST_EN)
    #define Iout_SIO_REG_HIFREQ     (* (reg8 *) Iout__SIO_REG_HIFREQ)
    #define Iout_SIO_CFG            (* (reg8 *) Iout__SIO_CFG)
    #define Iout_SIO_DIFF           (* (reg8 *) Iout__SIO_DIFF)
#endif /* (Iout__SIO_CFG) */

/* Interrupt Registers */
#if defined(Iout__INTSTAT)
    #define Iout_INTSTAT            (* (reg8 *) Iout__INTSTAT)
    #define Iout_SNAP               (* (reg8 *) Iout__SNAP)
    
	#define Iout_0_INTTYPE_REG 		(* (reg8 *) Iout__0__INTTYPE)
#endif /* (Iout__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Iout_H */


/* [] END OF FILE */
