/*******************************************************************************
* File Name: Op2in.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Op2in_H) /* Pins Op2in_H */
#define CY_PINS_Op2in_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Op2in_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Op2in__PORT == 15 && ((Op2in__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Op2in_Write(uint8 value);
void    Op2in_SetDriveMode(uint8 mode);
uint8   Op2in_ReadDataReg(void);
uint8   Op2in_Read(void);
void    Op2in_SetInterruptMode(uint16 position, uint16 mode);
uint8   Op2in_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Op2in_SetDriveMode() function.
     *  @{
     */
        #define Op2in_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Op2in_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Op2in_DM_RES_UP          PIN_DM_RES_UP
        #define Op2in_DM_RES_DWN         PIN_DM_RES_DWN
        #define Op2in_DM_OD_LO           PIN_DM_OD_LO
        #define Op2in_DM_OD_HI           PIN_DM_OD_HI
        #define Op2in_DM_STRONG          PIN_DM_STRONG
        #define Op2in_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Op2in_MASK               Op2in__MASK
#define Op2in_SHIFT              Op2in__SHIFT
#define Op2in_WIDTH              1u

/* Interrupt constants */
#if defined(Op2in__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Op2in_SetInterruptMode() function.
     *  @{
     */
        #define Op2in_INTR_NONE      (uint16)(0x0000u)
        #define Op2in_INTR_RISING    (uint16)(0x0001u)
        #define Op2in_INTR_FALLING   (uint16)(0x0002u)
        #define Op2in_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Op2in_INTR_MASK      (0x01u) 
#endif /* (Op2in__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Op2in_PS                     (* (reg8 *) Op2in__PS)
/* Data Register */
#define Op2in_DR                     (* (reg8 *) Op2in__DR)
/* Port Number */
#define Op2in_PRT_NUM                (* (reg8 *) Op2in__PRT) 
/* Connect to Analog Globals */                                                  
#define Op2in_AG                     (* (reg8 *) Op2in__AG)                       
/* Analog MUX bux enable */
#define Op2in_AMUX                   (* (reg8 *) Op2in__AMUX) 
/* Bidirectional Enable */                                                        
#define Op2in_BIE                    (* (reg8 *) Op2in__BIE)
/* Bit-mask for Aliased Register Access */
#define Op2in_BIT_MASK               (* (reg8 *) Op2in__BIT_MASK)
/* Bypass Enable */
#define Op2in_BYP                    (* (reg8 *) Op2in__BYP)
/* Port wide control signals */                                                   
#define Op2in_CTL                    (* (reg8 *) Op2in__CTL)
/* Drive Modes */
#define Op2in_DM0                    (* (reg8 *) Op2in__DM0) 
#define Op2in_DM1                    (* (reg8 *) Op2in__DM1)
#define Op2in_DM2                    (* (reg8 *) Op2in__DM2) 
/* Input Buffer Disable Override */
#define Op2in_INP_DIS                (* (reg8 *) Op2in__INP_DIS)
/* LCD Common or Segment Drive */
#define Op2in_LCD_COM_SEG            (* (reg8 *) Op2in__LCD_COM_SEG)
/* Enable Segment LCD */
#define Op2in_LCD_EN                 (* (reg8 *) Op2in__LCD_EN)
/* Slew Rate Control */
#define Op2in_SLW                    (* (reg8 *) Op2in__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Op2in_PRTDSI__CAPS_SEL       (* (reg8 *) Op2in__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Op2in_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Op2in__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Op2in_PRTDSI__OE_SEL0        (* (reg8 *) Op2in__PRTDSI__OE_SEL0) 
#define Op2in_PRTDSI__OE_SEL1        (* (reg8 *) Op2in__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Op2in_PRTDSI__OUT_SEL0       (* (reg8 *) Op2in__PRTDSI__OUT_SEL0) 
#define Op2in_PRTDSI__OUT_SEL1       (* (reg8 *) Op2in__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Op2in_PRTDSI__SYNC_OUT       (* (reg8 *) Op2in__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Op2in__SIO_CFG)
    #define Op2in_SIO_HYST_EN        (* (reg8 *) Op2in__SIO_HYST_EN)
    #define Op2in_SIO_REG_HIFREQ     (* (reg8 *) Op2in__SIO_REG_HIFREQ)
    #define Op2in_SIO_CFG            (* (reg8 *) Op2in__SIO_CFG)
    #define Op2in_SIO_DIFF           (* (reg8 *) Op2in__SIO_DIFF)
#endif /* (Op2in__SIO_CFG) */

/* Interrupt Registers */
#if defined(Op2in__INTSTAT)
    #define Op2in_INTSTAT            (* (reg8 *) Op2in__INTSTAT)
    #define Op2in_SNAP               (* (reg8 *) Op2in__SNAP)
    
	#define Op2in_0_INTTYPE_REG 		(* (reg8 *) Op2in__0__INTTYPE)
#endif /* (Op2in__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Op2in_H */


/* [] END OF FILE */
