/*******************************************************************************
* File Name: Opein.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Opein_H) /* Pins Opein_H */
#define CY_PINS_Opein_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Opein_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Opein__PORT == 15 && ((Opein__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Opein_Write(uint8 value);
void    Opein_SetDriveMode(uint8 mode);
uint8   Opein_ReadDataReg(void);
uint8   Opein_Read(void);
void    Opein_SetInterruptMode(uint16 position, uint16 mode);
uint8   Opein_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Opein_SetDriveMode() function.
     *  @{
     */
        #define Opein_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Opein_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Opein_DM_RES_UP          PIN_DM_RES_UP
        #define Opein_DM_RES_DWN         PIN_DM_RES_DWN
        #define Opein_DM_OD_LO           PIN_DM_OD_LO
        #define Opein_DM_OD_HI           PIN_DM_OD_HI
        #define Opein_DM_STRONG          PIN_DM_STRONG
        #define Opein_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Opein_MASK               Opein__MASK
#define Opein_SHIFT              Opein__SHIFT
#define Opein_WIDTH              1u

/* Interrupt constants */
#if defined(Opein__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Opein_SetInterruptMode() function.
     *  @{
     */
        #define Opein_INTR_NONE      (uint16)(0x0000u)
        #define Opein_INTR_RISING    (uint16)(0x0001u)
        #define Opein_INTR_FALLING   (uint16)(0x0002u)
        #define Opein_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Opein_INTR_MASK      (0x01u) 
#endif /* (Opein__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Opein_PS                     (* (reg8 *) Opein__PS)
/* Data Register */
#define Opein_DR                     (* (reg8 *) Opein__DR)
/* Port Number */
#define Opein_PRT_NUM                (* (reg8 *) Opein__PRT) 
/* Connect to Analog Globals */                                                  
#define Opein_AG                     (* (reg8 *) Opein__AG)                       
/* Analog MUX bux enable */
#define Opein_AMUX                   (* (reg8 *) Opein__AMUX) 
/* Bidirectional Enable */                                                        
#define Opein_BIE                    (* (reg8 *) Opein__BIE)
/* Bit-mask for Aliased Register Access */
#define Opein_BIT_MASK               (* (reg8 *) Opein__BIT_MASK)
/* Bypass Enable */
#define Opein_BYP                    (* (reg8 *) Opein__BYP)
/* Port wide control signals */                                                   
#define Opein_CTL                    (* (reg8 *) Opein__CTL)
/* Drive Modes */
#define Opein_DM0                    (* (reg8 *) Opein__DM0) 
#define Opein_DM1                    (* (reg8 *) Opein__DM1)
#define Opein_DM2                    (* (reg8 *) Opein__DM2) 
/* Input Buffer Disable Override */
#define Opein_INP_DIS                (* (reg8 *) Opein__INP_DIS)
/* LCD Common or Segment Drive */
#define Opein_LCD_COM_SEG            (* (reg8 *) Opein__LCD_COM_SEG)
/* Enable Segment LCD */
#define Opein_LCD_EN                 (* (reg8 *) Opein__LCD_EN)
/* Slew Rate Control */
#define Opein_SLW                    (* (reg8 *) Opein__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Opein_PRTDSI__CAPS_SEL       (* (reg8 *) Opein__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Opein_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Opein__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Opein_PRTDSI__OE_SEL0        (* (reg8 *) Opein__PRTDSI__OE_SEL0) 
#define Opein_PRTDSI__OE_SEL1        (* (reg8 *) Opein__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Opein_PRTDSI__OUT_SEL0       (* (reg8 *) Opein__PRTDSI__OUT_SEL0) 
#define Opein_PRTDSI__OUT_SEL1       (* (reg8 *) Opein__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Opein_PRTDSI__SYNC_OUT       (* (reg8 *) Opein__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Opein__SIO_CFG)
    #define Opein_SIO_HYST_EN        (* (reg8 *) Opein__SIO_HYST_EN)
    #define Opein_SIO_REG_HIFREQ     (* (reg8 *) Opein__SIO_REG_HIFREQ)
    #define Opein_SIO_CFG            (* (reg8 *) Opein__SIO_CFG)
    #define Opein_SIO_DIFF           (* (reg8 *) Opein__SIO_DIFF)
#endif /* (Opein__SIO_CFG) */

/* Interrupt Registers */
#if defined(Opein__INTSTAT)
    #define Opein_INTSTAT            (* (reg8 *) Opein__INTSTAT)
    #define Opein_SNAP               (* (reg8 *) Opein__SNAP)
    
	#define Opein_0_INTTYPE_REG 		(* (reg8 *) Opein__0__INTTYPE)
#endif /* (Opein__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Opein_H */


/* [] END OF FILE */
