/* ========================================
 *
 * Copyright PG
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * ========================================
*/
//#include <device.h>
#include <stdlib.h>
//#include <arith.h>
#include <stdio.h>
#include <math.h>  
#include <string.h>
#include <project.h>

#define R1 1
#define R2 2 
#define R3 4 
#define R4 8
#define V5_enable 1

#define RRef1 11050000          //Wert von Referenzwiderstand 1 11,04 Ohm - Value for Resistor 1
#define RRef2 201900000         //Wert von Referenzwiderstand 2 201,9 Ohm - Value for Resistor 2
#define RRef3 1009800000        //Wert von Referenzwiderstand 3 1,0098kOhm - Value for Resistor 3
#define RRef4 1010900000000    //Wert von Referenzwiderstand 4 1,0109MOhm - Value for Resistor 4

#define Dauer 669               //Wert von Periodendauer in ns              - Value for time in ns
#define Pi 3141590000             //Wert von Pi                             - Value for Pi

#define REFHI_MV (4993) /* Value (mV) of P0[1] in Strong Drive mode after CalibPin_Write(1) called */
#define REFLOW_MV    (0) /* Value (mV) of P0[1] in Strong Drive mode after CalibPin_Write(0) called */

#define Schritt (Ub+200000)/65536 // Schrittöhe des ADC berechnen - calculate voltage for 1 step of ADC 
#define Ub 4993000       // Wert der Betriebsspannung in uVolt - value of supplyvoltage

//uint32_t Ub;
uint32_t U;
int i = 65535 ;             // Zählvariable für Frequenz - counting variable for frequency
int Period;                 // Variable für Period aus Sinus_Counter - variable for period form sinus-counter
int Ende = 0;               // Variable für Abbruch der Frequenzerzeugung - variable to stop the frequency moving
uint8_t Button1State = 0; // Variable für Zustand von Taster 1 - state of button1
uint8_t Button2State = 0; // Variable für Zustand von Taster 2 - state of button2
uint8_t Button3State = 0; // Variable für Zustand von Taster 3 - state of button3
uint16_t ADCResult;         // Variable für Zwischenspeichern des ADC-Ergebnisses - store the result of the ADC  
uint64_t temp;                 // Zwischenspeicher für Ergebnis - temporary memory for result
uint64_t erg2 = 0;             // Variable für Ergebnis
int s;                        //Zwischenspeicher für Stellen des Ergebnisses
int x;          //Zählvariable für Zehnerpotenzen
int a=1,b=1,c=1, d=1;  // Multiplikatoren für Wertigkeiten 
int l,m,n,o, p;         // Position auf Display
int z;
int number;
int count = 0;
unsigned char Pointer;   // - Variable die auf Tabellenplatz zeigt - Variable to hold the index into the lookup table        
char ergebnis [12]; 
char ergebnis2 [9];
 uint32 source;       
const unsigned char SineTable[] = {
127, 176, 217, 244, 
254, 244,  217, 176, 
127,  78,  37, 10,
0, 10,  37,  78, 
 
}; // Werte für Sinus-Erzeugung -  samples for sine stored in ROM
 /*

127, 176, 217, 244, 
254, 244,  217, 176, 
127,  78,  37, 10,
0, 10,  37,  78,
16 Werte für Sinus

127,  217,  
254,   217, 
127,   37, 
0,  37,  
8 Werte für Sinus
 
*/

uint32_t expo10 (uint8_t e)         //Funktion zum errechnen der Zehnerpotenzen
{
  uint32_t x = 1;
  for (z = 0; z < e; z++) {
    x = x * 10;
  }
  return x;
}    

void Deziausgabe_R (uint64_t Ausgabe){
s = 0;                  //s zurücksetzen
temp = Ausgabe;
    
while(temp!=0)          // Stellen des Ergebnisses zählen
{
  temp= temp / 10;
   s++;
}    

    a= expo10 (s-4);               //  LSB 
    b= expo10 (s-3);
    c= expo10 (s-2);
    d= expo10 (s-1);            //  MSB
    
//                LCD_Position(0,0);                     //Cursor an Anfang setzen - set cursor to 0,0
//                sprintf(ergebnis , "%u" , s);   // Umwandlung von float in char-Array sprintf(string, 2 nachkommastellen  ,float) 
//                LCD_PrintString(ergebnis);
    
    unsigned char erg_a, erg_b, erg_c, erg_d ;      //Stellen des Ergebnisses in char umwandeln
    erg_a = (Ausgabe /a)%10;                        //LSB 4. Stelle
    erg_b = (Ausgabe /b)%10;                        // 3. Stelle
    erg_c = (Ausgabe /c)%10;                        // 2. Stelle
    erg_d = (Ausgabe /d)%10;                        //MSB   1. Stelle
    
    // Komma verschieben
    if ((s)%4 ==0){l= 7; m=8; n=10; o=9; p=11;}     //"o" ist Variable für Position des Komma
    if ((s)%4 ==1){l= 7; m=8; n=9; o=10; p=11;}
    if ((s)%4 ==2){l= 7; m=9; n=10; o=8; p=11;}
    if ((s)%4 ==3){l= 7; m=9; n=10; o=8; p=11;}
    
    //chars mit Ergebnis an Position der Variablen aus "Komma verschieben" ausgeben 
    LCD_Position(1,l);
    LCD_WriteData(0x30+erg_d); // MSB 
    LCD_Position(1,m);
    LCD_PutChar(0x30+erg_c ); 
    LCD_Position(1,n);
    LCD_PutChar(0x30+erg_b );
    LCD_Position(1,o);
    LCD_PrintString(",");
    LCD_Position(1,p);
    LCD_PutChar(0x30+erg_a );  //LSB
    // Überprüfen welcher Präfix vor der Einheit ausgegeben werden muss und Präfix ausgeben
//    if (s>=0 && s<=3){
//    LCD_Position(1,14);
//    LCD_PrintString("\344");}   //mikro   
    if (s>=4 && s<=6){
    LCD_Position(1,12);
    LCD_PrintString("m");}      //milli
    if (s>=7 && s<=9){
    LCD_Position(1,12);
    LCD_PrintString(" ");}       // Ohm
    if (s>=10 && s<=12){
    LCD_Position(1,12);
    LCD_PrintString("k");}      //kilo 
    if (s>=13 && s<=15){
    LCD_Position(1,12);
    LCD_PrintString("M");}      //Mega

//    if (s>=16 || 18<=s){
//    LCD_Position(1,14);
//    LCD_PrintString("k");}
//    if (s>=19 || 21<=s){
//    LCD_Position(1,14);
//    LCD_PrintString("M");} 
}    
CY_ISR(Sinus) {
    
    //source = Counter_Sinus_GetInterruptSourceMasked();

    IDAC_SetValue(SineTable[Pointer]); //IDAC mit Wert aus tabelle füttern - give the IDAC the value from the table
    Pointer++; 
    if (Pointer >= 16) {
    Pointer = 0; 
    }
    Counter_Sinus_ReadStatusRegister(); //clear interrupt
    //Counter_Sinus_ClearInterrupt(source);   
}

/******************************************************************************
* Function Name: Buttonx_ISR()
******************************************************************************
* Summary:
*   Interrupt-Service-Routine die Bei Druck auf Button ausgelöst und
*   button1_State auf 1 gesetzt wird.
*
* Parameter:
*   keine
*
* Rückgabewerte:
*  Keine,  button1_State wird auf 1 gesetzt
*
*****************************************************************************/
CY_ISR(Button1_ISR)
{
	/*Interrupt-Quelle muss nicht zurückgesetzt werden; Interrupt-Komponente muss
	* als RISING_EDGE konfiguriert sein.
    *
	* Lesen des FiltReg1 um es zurückzusetzen, der eigentliche Inhalt muss nicht geprüft werden.
    *
    *No Need to reset interrupt source; must be configured for RISING_EDGE
    *
    *Read FiltReg1 to reset, checking actual value is not necessary
	*/
	//FiltReg1_Read();
	
	Button1State=1;
} //Button1_ISR   

CY_ISR(Button2_ISR)
{
	/*Interrupt-Quelle muss nicht zurückgesetzt werden; Interrupt-Komponente muss
	* als RISING_EDGE konfiguriert sein.
    *
	* Lesen des FiltReg1 um es zurückzusetzen, der eigentliche Inhalt muss nicht geprüft werden.
    *
    *No Need to reset interrupt source; must be configured for RISING_EDGE
    *
    *Read FiltReg1 to reset, checking actual value is not necessary
	*/
	Button2State=1;
} //Button2_ISR   

CY_ISR(Button3_ISR)
{
	/*Interrupt-Quelle muss nicht zurückgesetzt werden; Interrupt-Komponente muss
	* als RISING_EDGE konfiguriert sein.
    *
	* Lesen des FiltReg1 um es zurückzusetzen, der eigentliche Inhalt muss nicht geprüft werden.
    *
    *No Need to reset interrupt source; must be configured for RISING_EDGE
    *
    *Read FiltReg1 to reset, checking actual value is not necessary
	*/
	//FiltReg3_Read();
	
	Button3State=1;
} //Button1_ISR                                 

CY_ISR(Freq_erreicht_ISR)
{
	Period=i;
    Ende = 1;
	
} //Freq_erreicht_ISR        

int main() // Hauptprogramm
{
    //Intialisierungen - Initializations
    LCD_Init(); //LCD Initialisieren -  initialize LCD
        
    ADC_Del_Start();   // Starte den ADC - start ADC
    
    Button1_StartEx(Button1_ISR);
	Button1_ClearPending(); 
    
    Button2_StartEx(Button2_ISR);
	Button2_ClearPending(); 
    
    Button3_StartEx(Button3_ISR);
	Button3_ClearPending(); 
    // ISR für Taster starten - start ISR for buttons
    
    CyGlobalIntEnable; //Globale Interrupts aktivieren - activate global interrupts
    
     // Ende Initialisierungen - end of Initialization
      
    while(1) {// Endlosschleife für Hauptprogramm - infinite loop for main
        // Variablen - Variables
        Pointer = 0;    
        uint64_t ergc = 12;
        uint64_t erg1 = 0;
        uint64_t u =0;
        uint8_t status;
        //int wait;
        int i = 65535 ;
        //int diff, diff2;
        uint64_t Freq; 
        uint64_t Zaehler; 
        int64_t ets;
        uint64_t ADC =0;
        uint64_t Offset =0;
        uint64_t Vdd;
        //uint32_t SARControlReg;
 
        int32 voltageCal_mv; /* After 2-point calibration, stores voltage with offset and gain adjustments applied */
    int32 calPoint1;     /* First point used in 2-point calibration */
    int32 calPoint2;     /* Second point used in 2-point calibration */
    int32 voltageOffset_mv = 0;  /* Stores the offset after 2-point calibration.
                                    Initially 0 as a failsafe. */
    int32 voltageGainAdjust_ppt = 1000; /* Stores the gain adjustment after 2-point calibration.
                                           Initially 1000 as a failsafe.*/
        
        
        // Variablen Ende
        
        LCD_Start();
        LCD_DisplayOn();
        LCD_ClearDisplay(); // Display starten, anschalten, und leeren - Start, turn on and clear display

        LCD_Position(0,2);                     //Cursor an Anfang setzen - set cursor to 0,0
        LCD_PrintString("Tastendruck");           // Tastendruck ausgeben in oberer Zeile - print Tastendruck in first row
        LCD_Position(1,0);                     //Cursor auf zweite Zeile Anfang setzen - set cursor to 1,0
        LCD_PrintString("startet Messung");     // Ausgabe in zweiter Zeile  - print text in second row
        CyDelay(200); 
/*
 Widerstandsmessung
 
 Widerstandsmessung mit RRef2 beginnen!      
*/  
            if (Button1State >0) {              //Wenn Taster1 gedrückt wurde -  If button1 is pressed         
                LCD_ClearDisplay();
                //ADC_Del_SelectConfiguration(1 , 1);
                ADC_Del_StartConvert();    // Starte den ADC - start the ADC
                
             
 
    /******* Perform two-point calibration *******/    
    /* The input voltage is an unknown.  Assuming the ADC interprets the input 
    with some offset and gain error, it can be modeled as a linear equation:
    y = mx + b     Where y = voltage_mv, m = 1/voltageGainAdjust_ppt, 
    b = voltageOffset_mv, x = voltageCal_mv. Using two known input voltages, 
    we can calculate the offset and gain error. */
     Control_Reg_Write(0);
     V5_Write(0);           
    /* Set CalibPin to VSS (low).  Get Point 1. */
    Pin_Cal_Write(0);
    CyDelay(500);
     //ADC = ADC_Del_GetResult32(); //Ergebnis in ADC ablegen - store result in ADC
    calPoint1 = ADC_Del_CountsTo_mVolts(ADC_Del_GetResult32()); /* Point 1 is now (REFLOW_MV, calPoint1) */
    
    /* Set Pin to VDD (high).  Get Point 2. */
    Pin_Cal_Write(1);
    CyDelay(500);
    calPoint2 = ADC_Del_CountsTo_mVolts(ADC_Del_GetResult32());  /* Point 2 is now (REFHI_MV, calPoint2) */
    
    /** Calculate offset and gain adjustment.  Calculations also explained in 
    example datasheet **/

    /* Find offset voltage by finding the y-intercept of the line created by the two points.
       The two points are (REFLOW_MV, calPoint1) and (REFHI_MV, calPoint2)
       Recall y = mx + b     and     m = (y2 - y1)/(x2 - x1)
       Rearranging and substituting m, b = y - x*(y2 - y1)/(x2 - x1) 
       Substitute either point for y & x, b = y2 - x2*(y2 - y1)/(x2 - x1) */
    voltageOffset_mv = calPoint2 - (REFHI_MV*(calPoint2 - calPoint1))/(REFHI_MV - REFLOW_MV);
    
    /* Find gain adjustment by solving for slope. m = (y - b)/x
       Substitute either point for y & x, m = (y2 - b)/x2 
       As a design choice, instead of dividing by m later, we calculate 1/m here.
       To keep accuracy while using integer calculations, the numerator is pre-
       scaled by 1000.
       1/m = 1000*x2/(y2 - b)
       This scaling is undone later when we apply the gain adjustment to inputs. */
    voltageGainAdjust_ppt = (REFHI_MV*1000)/(calPoint2 - voltageOffset_mv);
    
    /* Disconnect CalibPin by setting its drive mode to analog high-z */
    Pin_Cal_SetDriveMode(Pin_Cal_DM_ALG_HIZ);
                
    /**********End two-point calibration**********/            
                
    //Note that I only tried the calibration in the first function for measuring, when that is running I will adapt it to the other cases             
                while (Button2State==0 && Button3State==0){
                
                LCD_Position(0,3);                     //Cursor an Anfang setzen - set cursor to 0,0
                LCD_PrintString("R-Messung");           // R-Messung ausgeben in oberer Zeile - print R-Messung in first row
                V5_Write(V5_enable);
                Control_Reg_Write(0);                   //Alle Widerstände deaktivieren - deactivate all Resistors
                Control_Reg_Write(R2);                  // Widerstand R2 aktivieren  - activate R2          
                CyDelay(5);                             // 5us warten - wait 5us
                

                ADC_Del_IsEndConversion(ADC_Del_WAIT_FOR_RESULT);    // Auf Bereitschaft des ADC warten - wait till ADC is ready
                u = ADC_Del_CountsTo_mVolts(ADC_Del_GetResult32());     //Wert in mV vom ADC bekommen- get value in mV from ADC
               
                voltageCal_mv = ((u - voltageOffset_mv)*voltageGainAdjust_ppt)/1000; // use the values of the calibration
                voltageCal_mv = voltageCal_mv*1000; // create uVolts
                
               
                Vdd = Ub - voltageCal_mv;//u; //Spannung über dem bekannten Widerstand bestimmen - calculate voltage for known resistor of voltage divider
                erg1 = Vdd*RRef2;  // Rx= ((RRef2*(Ub-u))/(u)) Widerstandswert berechnen - calculate resistor-value 
                erg2 = (erg1/u);

                LCD_Position(0,0);                     //Cursor an Anfang setzen - set cursor to 0,0
                sprintf(ergebnis , "%u" , voltageCal_mv);   // Umwandlung von float in char-Array sprintf(string, 2 nachkommastellen  ,float) 
                LCD_PrintString(ergebnis);       

                
                if (erg2>5000000000){
                    
                        Control_Reg_Write(0);    
                        Control_Reg_Write(R3);
                        V5_Write(V5_enable);
                        CyDelay(5);
                        //0+1492

                        //ADC1_IsEndConversion(ADC1_WAIT_FOR_RESULT);  
                        ADC = ADC_Del_GetResult32(); //Ergebnis in Vref ablegen - store result in Vref
                        ADC=ADC+880; //Offset von Messung unter 0
                        Offset= (ADC*2)/10;
                        u = ((ADC *Schritt)-Offset ) ;  //Wert mal 76uVolt = Spannung in uVolt - kommt von 42828/2^16 + 5mV offset - calculate the actual value in uVolt
                        //u = Vref *1611 ; //Wert mal 1611uVolt = Spannung in uVolt - kommt von 3,3/2^11 - calculate the actual value in uVolt
                        Vdd = Ub-u; //Spannung über dem bekannten Widerstand bestimmen - calculate voltage for known resistor of voltage divider 3389000
                        erg1 = Vdd*RRef3;  // Rx= ((R1*5-ADC1)/(ADC1)) Widerstandswert berechnen - calculate resistor-value 
                        erg2 = (erg1/u);
                        
//                        LCD_Position(0,0);                     //Cursor an Anfang setzen - set cursor to 0,0
//                        sprintf(ergebnis , "%u" , Vref);   // Umwandlung von float in char-Array sprintf(string, 2 nachkommastellen  ,float) 
//                        LCD_PrintString(ergebnis);                         
                }// if ergr > 5KOhm
                
                if (erg2>50000000000){
                    
                        Control_Reg_Write(0);    
                        Control_Reg_Write(R4);
                        V5_Write(V5_enable);
                         CyDelay(5);
                        //0+1492

                        //ADC1_IsEndConversion(ADC1_WAIT_FOR_RESULT);  
                        ADC = ADC_Del_GetResult32(); //Ergebnis in Vref ablegen - store result in Vref
                        ADC=ADC+880; //Offset von Messung unter 0
                        //Offset= (ADC*2)/10;
                        u = ((ADC *Schritt)-Offset ) ; //Wert mal 76uVolt = Spannung in uVolt - kommt von 42828/2^16 + 5mV offset - calculate the actual value in uVolt
                        //u = Vref *1611 ; //Wert mal 1611uVolt = Spannung in uVolt - kommt von 3,3/2^11 - calculate the actual value in uVolt
                        Vdd = Ub-u; //Spannung über dem bekannten Widerstand bestimmen - calculate voltage for known resistor of voltage divider 3389000
                        erg1 = Vdd*RRef4;  // Rx= ((R1*5-ADC1)/(ADC1)) Widerstandswert berechnen - calculate resistor-value 
                        erg2 = (erg1/u);
                                              
                }// if ergr > 50KOhm
                
                                            
                //CyDelay(200);                          // 200us warten 
                LCD_Position(1,0);                     //Cursor auf zweite Zeile Anfang setzen - set cursor to second row
                LCD_PrintString("R=");     // Ausgabe in zweiter Zeile   - print Ergebnis in second row
                Deziausgabe_R(erg2);

                LCD_Position(1,13);
                LCD_PrintString("\364");          //Grosses Omega für Ohm ausgeben - print Ohm
                CyDelay(200);                 
                
                //CyPins_ClearPin(V3out);           // Pin 1 auf Low setzen - set Pin1 to low
                
                } //while (button2State==0 && button3State==0)
                Button1State =0;                  // Button1State zurücksetzen - reset button1state
            } // if               
/*
 Kapazitätsmessung          
*/            
            if (Button2State>0) {      //Wenn Taster2 gedrückt wurde -  If button2 is pressed  
                    LCD_ClearDisplay();
                    IDAC_Start();
                    Counter_Sinus_Start();
                        //Counter_Sinus_SetInterruptMode(TCPWM_INTR_MASK_TC);    
                    //Opamp_Start();
                    //Opamp_1_Start();
                    //Opamp_1_Start();
                //Opamp_2_Start();
                //PGA_1_Start();
                    i= 65535;
                    Sinus_StartEx(Sinus);    // Interrupt für Sinus starten - start the interrupts for sine-generation 
                    while (Button1State==0 && Button3State==0){
                        //LCD_Position(0,0);                     //Cursor an Anfang setzen - set cursor to first row
                        //LCD_PrintString("//C-Messung\\"); 

                        // Unterscheidung wo i ist => Durchlauf beschleunigen
                        //U spitze spitze messen => kleinstes u = grenzfrequenz
                        // grenzfrequenz berechnen
                        //c berechnen
                        //ADC_Del_StartConvert();    // Starte den ADC - start the ADC   
                        // i beschleunigen


                        //  while (diff2){    
                        LCD_Position(0,2);                     //Cursor an Anfang setzen - set cursor to first row
                        LCD_PrintString("**Messung**"); 
//                        LCD_Position(1,10);                     //Cursor an Anfang setzen - set cursor to 0,0
//                        sprintf(ergebnis2 , "%u" ,i);   // Umwandlung von float in char-Array sprintf(string, 2 nachkommastellen  ,float) 
//                        LCD_PrintString(ergebnis2);  
                        Control_Reg_Write(0);    
                     Control_Reg_Write(R1); 
                        
                        while (Ende == 0){
                        if(i>=25000){
                            i=i-5;
                            Counter_Sinus_WritePeriod(i); }

                        if (i>=9000){
                            i=i-10;
                            Counter_Sinus_WritePeriod(i); }  
                            
                        if(i>=208){
                            i--;
                            Counter_Sinus_WritePeriod(i);
                            CyDelay(2);}

                        } //while
                            
                        //Frequenz berechnen
                        
                        Freq =  Dauer * Period;
                        
                        Zaehler = 2*Pi*(RRef1*1000)*Freq;
                        ergc = 1000000000/Zaehler;
                        LCD_Position(1,10);                     //Cursor an Anfang setzen - set cursor to 0,0
                        sprintf(ergebnis2 , "%u" ,ergc);   // Umwandlung von float in char-Array sprintf(string, 2 nachkommastellen  ,float) 
                        LCD_PrintString(ergebnis2);  
                        
                        
                    LCD_Position(0,3);                     //Cursor an Anfang setzen - set cursor to first row
                    LCD_PrintString("C-Messung");           // C-Messung ausgeben in oberer Zeile  -  print C-Messung in first row
                    //CyDelay(200);                          // 200us warten 
                    LCD_Position(1,0);                     //Cursor auf zweite Zeile Anfang setzen - set cursor to second row
                    //status = sprintf(ergebnis, "%u", ergc);   // Umwandlung von uint in char-Array - convert from int to string
                    LCD_Position(1,0);
                    LCD_PrintString("C=");     // Ausgabe in zweiter Zeile   print ergebnis in second row
                     LCD_Position(1,15);
                    LCD_PrintString("F");  
                    //CyDelay(500); 
                    } //while (button1State==0 && button3State==0)
                Sinus_Stop();    // Interrupt für Sinus stoppen - stop the interrupts for sine-generation                     
                Button2State = 0;            // Button2State zurücksetzen - reset button2state
            } // if   
/*
Induktivitätsmessung          
*/  

            if (Button3State>0) {                 
                 LCD_ClearDisplay(); 
                while (Button1State==0 && Button2State==0){
                   
                    LCD_Position(0,3);                     //Cursor an Anfang setzen
                    LCD_PrintString("L-Messung");           // L-Messung ausgeben in oberer Zeile - print L-Messung in first row
                    CyDelay(200);                          // 200us warten 
                    LCD_Position(1,0);                     //Cursor auf zweite Zeile Anfang setzen
                  //  status = sprintf(ergebnis, "%u", ergl);   // Umwandlung von int in char-Array - convert int to char
                    LCD_PrintString("L=");     // Ausgabe in zweiter Zeile  - print ergebnis in second row  
                    //CyDelay(500);
                    LCD_Position(1,15);                     //Cursor an Anfang setzen
                    LCD_PrintString("H");           // L-Messung ausgeben in oberer Zeile - print L-Messung in first row
                    
//                    Control_Reg_Write(R1); 
//                    CyDelay(3000);
//                     Control_Reg_Write(0); 
//                    CyDelay(3000);
//                     CyDelay(3000);
//                     Control_Reg_Write(R2); 
//                     CyDelay(3000);
                    
                    CyDelay(3000);
                     CyDelay(3000);
                     Control_Reg_Write(R4); 
                     CyDelay(3000);

                    
                    } //while (button1State==0 && button2State==0)
             Button3State = 0;            // Button3State zurücksetzen - reset button3state

            } // if   

                
  
  
    } //while(1)

    }// main

/* [] END OF FILE */
